From 805dca3e10ac26b0ed952e89db908a54a5207f2b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 30 2020 02:11:02 +0000
Subject: [PATCH 735/2232] Propagate unsafety from module to extern block


---

diff --git a/gen/src/mod.rs b/gen/src/mod.rs
index fa9e407..68c6f85 100644
--- a/gen/src/mod.rs
+++ b/gen/src/mod.rs
@@ -62,7 +62,8 @@ fn generate(source: &str, opt: Opt, header: bool) -> Result<Vec<u8>> {
         .next()
         .ok_or(Error::NoBridgeMod)?;
     let ref namespace = bridge.namespace;
-    let ref apis = syntax::parse_items(errors, bridge.content);
+    let trusted = bridge.unsafety.is_some();
+    let ref apis = syntax::parse_items(errors, bridge.content, trusted);
     let ref types = Types::collect(errors, apis);
     errors.propagate()?;
     check::typecheck(errors, namespace, apis, types);
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index aecec75..9cfe3b5 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -14,7 +14,8 @@ use syn::{parse_quote, Result, Token};
 pub fn bridge(mut ffi: Module) -> Result<TokenStream> {
     let ref mut errors = Errors::new();
     let content = mem::take(&mut ffi.content);
-    let ref apis = syntax::parse_items(errors, content);
+    let trusted = ffi.unsafety.is_some();
+    let ref apis = syntax::parse_items(errors, content, trusted);
     let ref types = Types::collect(errors, apis);
     errors.propagate()?;
     let namespace = &ffi.namespace;
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 7520644..415b802 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -20,7 +20,7 @@ pub mod kw {
     syn::custom_keyword!(Result);
 }
 
-pub fn parse_items(cx: &mut Errors, items: Vec<Item>) -> Vec<Api> {
+pub fn parse_items(cx: &mut Errors, items: Vec<Item>, trusted: bool) -> Vec<Api> {
     let mut apis = Vec::new();
     for item in items {
         match item {
@@ -32,7 +32,7 @@ pub fn parse_items(cx: &mut Errors, items: Vec<Item>) -> Vec<Api> {
                 Ok(enm) => apis.push(enm),
                 Err(err) => cx.push(err),
             },
-            Item::ForeignMod(foreign_mod) => parse_foreign_mod(cx, foreign_mod, &mut apis),
+            Item::ForeignMod(foreign_mod) => parse_foreign_mod(cx, foreign_mod, &mut apis, trusted),
             Item::Use(item) => cx.error(item, error::USE_NOT_ALLOWED),
             Item::Other(item) => cx.error(item, "unsupported item"),
         }
@@ -170,16 +170,20 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum) -> Result<Api> {
     }))
 }
 
-fn parse_foreign_mod(cx: &mut Errors, foreign_mod: ItemForeignMod, out: &mut Vec<Api>) {
+fn parse_foreign_mod(
+    cx: &mut Errors,
+    foreign_mod: ItemForeignMod,
+    out: &mut Vec<Api>,
+    trusted: bool,
+) {
     let lang = match parse_lang(&foreign_mod.abi) {
         Ok(lang) => lang,
         Err(err) => return cx.push(err),
     };
 
-    let trusted = foreign_mod.unsafety.is_some();
     match lang {
         Lang::Rust => {
-            if trusted {
+            if foreign_mod.unsafety.is_some() {
                 let unsafety = foreign_mod.unsafety;
                 let abi = foreign_mod.abi;
                 let span = quote!(#unsafety #abi);
@@ -189,6 +193,8 @@ fn parse_foreign_mod(cx: &mut Errors, foreign_mod: ItemForeignMod, out: &mut Vec
         Lang::Cxx => {}
     }
 
+    let trusted = trusted || foreign_mod.unsafety.is_some();
+
     let mut items = Vec::new();
     for foreign in &foreign_mod.items {
         match foreign {

